<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="query.title" :placeholder="$t('table.title')" style="width: 200px;" class="filter-item" @keyup.enter.native="handleFilter" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">
        {{ $t('table.search') }}
      </el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="generateReport">
        {{ $t('table.pdf') }}
      </el-button>
    </div>
    <!--<div ref="qrcode">&nbsp;</div>-->
    <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
      <el-table-column align="center" :label="$t('table.name')">
        <template slot-scope="scope">
          <span>{{ scope.row.id }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" :label="$t('form.subscriptionNumber')">
        <template slot-scope="scope">
          <span>{{ scope.row.subscription_number }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" :label="$t('table.code')">
        <template slot-scope="scope">
          <span>{{ scope.row.code }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" :label="$t('route.qrcodes')">
        <template slot-scope="scope">
          <qrcode :value="scope.row.code" :options="{ width: 200 }">&nbsp;</qrcode>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('row.operation')">
        <template slot-scope="scope">
          <span class="pointer fa fa-check mr-1 ml-1" @click="setAddress(scope.row.id)">&nbsp;</span>
          <span class="pointer fa fa-remove mr-1 ml-1" @click="rejectBani(scope.row.id)">&nbsp;</span>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total>0" :total="total" :page.sync="query.page" :limit.sync="query.limit" @pagination="getList" />
    <el-dialog :title="$t('route.qrcodes')" :visible.sync="qrcodesVisible">
      <div v-loading="qrcodesLoading" class="form-container">
        <el-form ref="verificationForm" :model="qrcode" label-position="left" class="register-form" style="max-width: 500px;">
          <el-form-item :label="$t('form.subscriptionNumber')" prop="mobile">
            <el-input v-model="qrcode.qrcodeSubscriptionNumber" :placeholder="$t('form.subscriptionNumber')" />
          </el-form-item>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="qrcodesVisible = false">
          {{ $t('table.cancel') }}
        </el-button>
        <el-button type="primary" @click="sendQrcode()">
          {{ $t('table.confirm') }}
        </el-button>
      </div>
    </el-dialog>
    <vue-html2pdf
      ref="html2Pdf"
      :show-layout="false"
      :enable-download="true"
      :preview-modal="true"
      :paginate-elements-by-height="1400"
      filename="qr-codes"
      :pdf-quality="2"
      pdf-format="a4"
      pdf-orientation="landscape"
      pdf-content-width="1000px"
    >
      <section slot="pdf-content">
        <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
          <el-table-column align="center" :label="$t('table.code')">
            <template slot-scope="scope">
              <span>{{ scope.row.id }}</span>
            </template>
          </el-table-column>
          <el-table-column align="center" :label="$t('route.qrcodes')" style="text-align: center !important;">
            <template slot-scope="scope">
              <qrcode :value="scope.row.id" :options="{ width: 50 }">&nbsp;</qrcode>
              <qrcode :value="scope.row.id" :options="{ width: 50 }">&nbsp;</qrcode>
            </template>
          </el-table-column>

        </el-table>
      </section>
    </vue-html2pdf>
  </div>
</template>

<script>
import Vue from 'vue';
import Pagination from '@/components/Pagination'; // Secondary package based on el-pagination
import Bani from '@/api/bani';
const baniResource = new Bani('bani');
import 'vue-select/src/scss/vue-select.scss';
import VueQrcode from '@chenfengyuan/vue-qrcode';
import VueHtml2pdf from 'vue-html2pdf';
import * as QRCode from 'easyqrcodejs';

Vue.component(VueQrcode.name, VueQrcode);

export default {
  name: 'BaniList',
  components: { Pagination, VueHtml2pdf },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    return {
      list: null,
      total: 0,
      qrcode: {},
      listLoading: true,
      qrcodesVisible: false,
      qrcodesLoading: false,
      query: {
        page: 1,
        limit: 15,
        title: '',
        role: '',
      },
      options: [],
    };
  },
  created() {
    this.getList();
  },
  mounted(){
    // Options
    var options = {
      text: 'hi hadi',
      width: 256,
      height: 256,
      logo: '/images/qrcode.png',
      logoWidth: 80, // widht. default is automatic width
      logoHeight: 80, // height. default is automatic height
      logoBackgroundColor: '#fffff', // Logo backgroud color, Invalid when `logBgTransparent` is true; default is '#ffffff'
      logoBackgroundTransparent: false, // Whether use transparent image, default is false

      // ====== Backgroud Image

      backgroundImage: '/images/qrcode.png', // Background Image
      backgroundImageAlpha: 1, // Background image transparency, value between 0 and 1. default is 1.
      autoColor: false,
    };

    // Create new QRCode Object
    new QRCode(this.$refs.qrcode, options);
  },
  methods: {
    generateReport() {
      this.$refs.html2Pdf.generatePdf();
    },
    async getList() {
      this.listLoading = true;
      const { result } = await baniResource.listQrcodes(this.query);
      this.list = result.rows;
      this.total = result.total;
      this.listLoading = false;
    },
    setAddress(id) {
      this.qrcode.id = id;
      this.qrcodesVisible = true;
    },
    async sendQrcode() {
      const { success } = await baniResource.sendQrcode(this.qrcode);
      if (success === true) {
        this.qrcodesVisible = false;
        this.getList();
      }
    },
    acceptBani(id) {
      this.manage.id = id;
      this.$confirm(this.$i18n.t(`dialog.isAccept`), this.$i18n.t(`dialog.confirm`), {
        confirmButtonText: this.$i18n.t(`dialog.confirm`),
        cancelButtonText: this.$i18n.t(`dialog.cancel`),
        type: 'success',
      })
        .then(async() => {
          const result = await baniResource.accept(this.manage);
          if (result.success === true) {
            this.getList();
          }
        })
      // .catch(err => {})
      ;
    },
    handleFilter() {
      this.query.page = 1;
      this.getList();
    },
    onSearch(search, loading) {
      fetch(
        '/api/searchUsers?q=' + search
      ).then(res => {
        res.json().then(json => (this.options = json.items));
        console.log(this.options);
        loading(false);
      });
    },
  },
};
</script>
